<?php
/**
 * $Horde: nic/subsystem.php,v 1.19 2007/01/02 00:41:47 jan Exp $
 *
 * Copyright 2003-2006 Mike Cochrane <mike@graftonhall.co.nz>
 *
 * See the enclosed file COPYING for license information (GPL). If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

@define('NIC_BASE', dirname(__FILE__));
require_once NIC_BASE . '/lib/base.php';
require_once NIC_BASE . '/lib/Status.php';
require_once NIC_BASE . '/lib/Device.php';
require NIC_BASE . '/config/devices.php';
require_once 'Horde/Text/Filter.php';

$storage = &Nic_Status::singleton();

$hostname = Util::getFormData('hostname');
$subsystem = Util::getFormData('subsystem');
$time = Util::getFormData('time', null);

if (isset($time)) {
    $details = $storage->retrieveStatusHistory($hostname, $subsystem, $time, $time);
    $details = $details[$time];
    $details['time'] = $time;
} else {
    $details = $storage->retrieveCurrentStatus($hostname, $subsystem);
}

$rawhistory = $storage->retrieveStatusHistory($hostname, $subsystem, time() - $prefs->getValue('history_hours') * 3600);
$history = array();
$lastchange = 0;
$key = 0;
foreach ($rawhistory as $key => $val) {
    if ($lastchange == 0) {
        $lastchange = $key;
        $history[$key] = $val;
    }
    if ($rawhistory[$lastchange]['status'] != $val['status']) {
        $lastchange = $key;
        $history[$key] = $val;
    }
}
$history[$key] = isset($rawhistory[$key]) ? $rawhistory[$key] : null;

/* Page variables. */
$title = _("Subsystem Status");

require NIC_TEMPLATES . '/common-header.inc';
require NIC_TEMPLATES . '/menu.inc';
require NIC_TEMPLATES . '/subsystem/subsystem.inc';

foreach ($devices as $device_id => $device) {
    if ($device['params']['hostname'] == $hostname && $device['params']['subsystem'] == $subsystem) {
        $dev = &Nic_Device::singleton($device['driver'], $device['params']);
        $dev->showDetails(NIC_TEMPLATES . '/device/', $device_id);
    }
}

require NIC_TEMPLATES . '/subsystem/footer.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
